#include <pic.h>
#include "lcd.h"

void wys_hex(unsigned char dana, char z, char y);
void DispHex(unsigned char dana, char x, char y );
void DispDec(unsigned int dana, char x, char y );
void DispBar(unsigned char dana);
unsigned int read_adc(void);


struct{
   char tms:1;
}bits;
#define tms bits.tms

unsigned int mSec,uSec;
//obsuga przerwnia od Timer - odliczanie opnie
static void interrupt
isr(void)         		// przerwanie od Timer0
{
   if(T0IF){             //zerowan ie flagi przerwania
      TMR0+=131;         //8MHz/4/16/125=1kHz T=1msek
      if(tms){
      --mSec;
      if(mSec==0)
      tms=0;
      }
      T0IF = 0;         // clear the interrupt flag
   }
}

void main(void){
unsigned int adc;
unsigned long volt;
	OPTION=0b00000011;//ustawienie TMR0
	T0IE = 1;		// odblokowanie przerwania od przepelnienia TMR0
	GIE = 1;		// Global interrupt enable
	TRISA=0xff;
	TRISC=0;
	TRISD=0;
	ADCON1=0x80;//napicie odniesienia Vss-VDD - wynik dosuniety do prawej
	ADCON0=0xc1;//Wejcie AN0, zegar RC,pomiar stop  
	ANSEL=1;	//RA0 wejcie analogowe
	ANSELH=0;
	
	//setup_adc_ports(sAN0|VSS_VDD);
	//setup_adc(ADC_CLOCK_INTERNAL);      
    //set_adc_channel(0);
	InicLcd();
	DispHex(0x23,1,1);
	while(1){
	delay_ms(50);
	adc=read_adc();
	DispBar(adc);
	volt=adc*200;
	volt=volt/100;
	DispDec(volt,1,1);
	}
}
unsigned int read_adc(void){
unsigned int adc;
	ADCON0=0xc3;
	while((ADCON0&2)==2);//czekaj na wyzerowanie GO/!DONE
	adc=ADRESH;
	adc=(adc<<8)|ADRESL;
	adc=adc>>2;	//konwersja do rozdzielczosci 8 bitowej
	return adc;
}
void DispBar(unsigned char dana){
	if(dana==0)
	{PORTC=0;
	 return;
	};
	switch (dana/32){
	case 0:
	PORTC=1;
	break;
	case 1:
	PORTC=2;
	break;
	case 2:
	PORTC=4;
	break;
	case 3:
	PORTC=8;
	break;
	case 4:
	PORTC=0x10;
	break;
	case 5:
	PORTC=0x20;
	break;
	case 6:
	PORTC=0x40;
	break;
	case 7:
	PORTC=0x80;
	break;
	}


}
void DispDec(unsigned int dana, char x , char y){
unsigned int dec[4];
	
	dec[0]=dana/100;
	dec[1]=(dana-(dec[0]*100))/10;
	dec[2]=(dana-((dec[0]*100)+(dec[1]*10)));
	PosLcd(x,y);
	WriteRd(dec[0]+0x30);
	WriteRd('.');
	WriteRd(dec[1]+0x30);
	WriteRd(dec[2]+0x30);
	DispLcd(" VOLT");

}

void DispHex(unsigned char dana, char x, char y)
{	
unsigned char hex;
	PosLcd(x,y);//wpisanie pozycji
	hex=dana&0xf0;//starsza czesc
	hex=hex>>4;
	 if(hex<10)
	 hex=hex+0x30;
	 else
	 hex=hex+0x37;
	 WriteRd(hex); 	
	hex=dana&0x0f;
	 if(hex<10)
	 hex=hex+0x30;
	 else
	 hex=hex+0x37;
	 WriteRd(hex);
	return;
}

void delay_ms(unsigned int msek){
	mSec=msek;
	TMR0|=131;
	tms=1;
	while(tms);
}
