#include "i2c_hwd.h"
//******************************************************
//procedura incjalizacji portu I2C Master 
//******************************************************
void OpenI2C(void){
	SSPADD=19;	//SCL=100kHz
	SSPCON=8;	//MSSP I2C Master
	TRISC3=1;	//SDA i SCL wejciowe 
	TRISC4=1;
	RCEN=1;
	SSPEN=1;	//odblokuj MSSP
	
}
//******************************************************
//procedura wysyania sekwencji START
//******************************************************
char i2c_start(void){
	SEN=1;			//incjowanie sekwencji START
	if(BCLIF==1)	//bad kolizji magistrali
	return(-1);
	while(SEN);		//czekaj na koniec sekwencji START
	return(0);
}
//******************************************************
//procedura wysyania sekwencji STOP
//******************************************************
void i2c_stop(void){
	PEN=1;			//inicjiowanie sekwencji STOP
	while(PEN);		//czekaj na koniec sekwencji STOP
}
//******************************************************
//procedura wysyania danej na magistral
//******************************************************
char i2c_write(unsigned char data){

	SSPBUF=data;	//zapisanie danej do SSPBUF - start transmisji
  	if (WCOL ){      // sprawdzenie czy nie ma kolizji na magistrali 
	WCOL=0;
   	return ( -1 );}
  	else
  	{
	while(RW);		//czkaj na wysanie danej i odebranie bitu ACK
	return(ACKSTAT);
   	}
}
//******************************************************
//procedura odczytania danej z magistrali 
//******************************************************
unsigned char i2c_read(unsigned char ack)
{
  	RCEN = 1;           //start odbierania jednego bajtu z magistrali
  	while (!BF );      	//czekaj na koniec odbirania 8 bitw 
	if(ack==0)
	ACKDT = 0;      	//ustawienie bitu potwierdzenia 
	else
	ACKDT=1;
    ACKEN = 1;          //start sekwencji wysyania bitu potwiertdzenia
	while(ACKEN);		//czekaj na zakonczenie sekwencji 
  return ( SSPBUF );    //powrt z odebranym bitem 
}
//******************************************************
//procedura wysyania sekwencji  RPEAD START
//******************************************************
void i2c_restart(void){

	RSEN=1;
	while(RSEN);
}
 



