#include <pic.h>
#include <stdio.h>
#include "lcd.h"

struct{
   char tms:1;
	char freq:1;
	char khz:1;
	char mhz:1;
	char ffz:1;

}bits;
#define tms bits.tms
#define freq bits.freq
#define khz bits.khz
#define mhz bits.mhz
#define ffz bits.ffz

unsigned int mSec,Base;
unsigned long Fr;
//unsigned char Per;

void Freq(void);
void DispFreqLite(unsigned long data);

static void interrupt
isr(void)         // Here be interrupt function - the name is unimportant.
{
	if(TMR2IF==1){
	
	if(freq){
	--Base;
	if(Base==0)
	  freq=0;	
			}
	TMR2IF=0;}

	if(TMR1IF==1&&TMR1IE==1)
	{++Fr;
	 TMR1IF=0;}

   	if(T0IF){             // timer interrupt      
      TMR0+=131;         //8MHz/4/16/125=1kHz T=1msek
      if(tms){
      --mSec;
      if(mSec==0)
      tms=0;
      }
      T0IF = 0;         // clear the interrupt flag
   }
}
void main(void){
char tab[10],j;


	OPTION=0b00000011;//ustawienie TMR0
	T2CON=0b00000111;//ustawienie TMR2
	TMR1CS=1;
	TMR1GE=0;
	T1SYNC=1;
	//TMR2ON=0;
	PR2=125;
	T0IE = 1;		// odblokowanie przerwania od przepelnienia TMR0
	TMR2IE=1;
	PEIE=1;
	GIE = 1;		// Global interrupt enable
	TRISD=0;
	TRISC7=0;
	InicLcd();
	//DispFreqLite(9999999);
	//while(1);
	PosLcd(1,1);
	DispLcd("f= ");
	while(1){
	
	Freq();
	delay_ms(500);
	}
}

void delay_ms(unsigned int msek){
	mSec=msek;
	TMR0|=131;
	tms=1;
	while(tms);
}
//***********************************************************
//funkcja wykonania jednego pomiaru czestotliwoci 
//i wyietlenia wyniku - zakres 1Hz....9 9999 999Hz
//***********************************************************
void Freq(void){
	
	Base=1000;
	freq=1;
	Fr=0;
	TMR1IE=0;
	TMR1L=0;
	TMR1H=0;
	TMR1IF=0;
	TMR1IE=1;
	TMR1ON=1;
	TMR2ON=1;
	TMR2=0;
	RC7=1;
	while(freq);
	RC7=0;
	TMR1ON=0;
	TMR1IE=0;
	TMR2ON=0;
	Fr=Fr<<8;
	Fr=Fr|TMR1H;
	Fr=Fr<<8;
	Fr=Fr|TMR1L;
	DispFreqLite(Fr);
		
}
//********************************************************
//funkcja wywietlania czstotliwoci zawartej w argumencie data
//zakres wywietlania 1.9 999 999Hz 
//wywietlanie w jednostkach Hz, kHz, lub MHz zalenie od wartoci 
//z kropk dziesitn 
//*********************************************************

void DispFreqLite(unsigned long data){
char tab[7],i,j,p;
unsigned long temp,temp1;
	PosLcd(4,1);
	DispLcd("                ");
	PosLcd(4,1);
	if(data>=10000000)	//zabezpieczenie przed przekroczeniem wartoci 
	{DispLcd("<out!>");
	 return;
	}
	//konwersja do wag dziesitnych (format DEC)
	tab[0]=data/(unsigned long)1000000;
	tab[1]=(data-tab[0]*(unsigned long)1000000)/100000;
	tab[2]=(data-tab[0]*(unsigned long)1000000-tab[1]*(unsigned long)100000)/10000;
	temp=data-tab[0]*(unsigned long)1000000-tab[1]*(unsigned long)100000-tab[2]*(unsigned long)10000;
	temp1=temp/1000;
	tab[3]=temp1;
	tab[4]=(temp-tab[3]*1000)/100;
	tab[5]=(temp-tab[3]*1000-tab[4]*100)/10;
	tab[6]=temp-tab[3]*1000-tab[4]*100-tab[5]*10;
	j=0;				//okrelenie iloc zer nieznaczcych 
	for(i=0;i<7;i++)
	{if(tab[i]==0)
	 if(i==j){
	 ++j; 
	 continue;}
	 else 		
     break;
	}
	p=0;			//okrelenie jednostki zakresu i miejsca kropki dziesitnej 
	if(data>=1000000)
	p=1;
	if(data<1000000&&data>=1000)
	p=4;
	for(i=j;i<7;i++)//wywietlenie cyfr wyniku 
	{if(i==p)
	 WriteRd(',');
	 WriteRd(tab[i]+0x30);
	}
	if(p==0)		//wyietlenie jednostki wyniku 
	DispLcd("Hz");
	if(p==4)
	DispLcd("kHz");
	if(p==1)
	DispLcd("MHz");
	
	 

}



