#include <pic.h>
#include "lcd.h"
#include "i2c.h"
//definicje makr manipulacji linii 

#define SW_SW2 	0x0b //SW2
#define SW_SW3 	0x07 //SW3
#define SW_SW1 	0x0d //SW1
#define SW_SW0 	0x0e //SW0
struct {
	unsigned char sek;
	unsigned char min;
	unsigned char godz;
	unsigned char dni;
	unsigned char data;
	unsigned char mies;
	unsigned char rok;
	unsigned char zmsek;
}czas;
void ReadRTC(void);
void WriteCzasRTC(void);
void WriteDataRTC(void);
void DispTime(char x, char y);
void SetCzasRTC(void);
void SetDataRTC(void);
void DispDay(char x, char y);
void DispMies(char x, char y);
void DispDec(unsigned char data, char x, char y);
void WriteControlRTC(unsigned char control);
void delay_ms(unsigned int msek);
unsigned char klaw(void);
struct{
   char tms:1;
   char fl:1;
   char flt1:1;

}bits;
#define tms bits.tms
#define fl bits.fl
#define flt1 bits.flt1

unsigned int mSec,uSec;
//obsuga przerwnia od Timer0 
static void interrupt
isr(void)         // przerwanie od Timer0
{
   if(T0IF){             //zerowan ie flagi przerwania
      TMR0+=131;         //8MHz/4/16/125=1kHz T=1msek
      if(tms){
      --mSec;
      if(mSec==0)
      tms=0;
      }
      T0IF = 0;         // clear the interrupt flag
   }
}
void main (void){
unsigned char kl;
	OPTION=0b00000011;//ustawienie TMR0
	T0IE = 1;		// odblokowanie przerwania od przepelnienia TMR0
	GIE = 1;		// Global interrupt enable
	ANSEL=0;
	ANSELH=0;		//PORTB cyfrowy 
	TRISD=0;
	OpenI2C();		//incjalizacja interfejsu I2C
	InicLcd();		//inicjalizacja wyietlacza 
	InicLcd();
	WriteControlRTC(0);
	ReadRTC();
	
	while(1){
	delay_ms(200);
	PosLcd(13,2);
	DispLcd("SW0");
	PosLcd(13,1);
	DispLcd("SW1");
	DispDay(8,1);	//wywietlenie dnia
	DispMies(1,1);	//wyietlenie miesica 
	while((PORTA&0x0f)==0x0f)
	DispTime(1,2);
	delay_ms(30);
	kl=(PORTA&0x0f);
	if(kl==SW_SW0)
	SetCzasRTC();
	if(kl==SW_SW1)
	SetDataRTC();
	}
}
void InicRTC(void){
czas.zmsek=0;	//inicjalizacja 
	czas.sek=0;
	czas.min=0;
	czas.godz=0;
	czas.dni=1;
	czas.data=1;
	czas.mies=1;
	czas.rok=1;
	WriteCzasRTC();
	WriteDataRTC();
}
/*************************************************************
funkcja wywietlania czasu
/*************************************************************/
void DispTime(char x, char y){
	ReadRTC();
	if(czas.sek==czas.zmsek)//sekundy sie nie zmieniy od ostaniego odczytania
	 return;
	czas.zmsek=czas.sek;	//nowa wartoc sekund
	PosLcd(1,2);			//pozycja wywietlania
	WriteRd(((czas.godz&0x30)>>4)+0x30);//wywietlenie godzin
	WriteRd((czas.godz&0x0f)+0x30);
	WriteRd(':');
	WriteRd(((czas.min&0x70)>>4)+0x30);//wywietlenie minut
	WriteRd((czas.min&0x0f)+0x30);
	WriteRd(':');
	WriteRd(((czas.sek&0x70)>>4)+0x30);//wywietlenie sekund
	WriteRd((czas.sek&0x0f)+0x30);
	if(czas.sek==0&&czas.min==0&&czas.godz==0){
	DispDay(8,1);
	DispMies(1,1);
	}
	
}
/*************************************************************
funkcja wywietlania dnia tygodnia
/*************************************************************/
void DispDay(char x, char y){
	PosLcd(x,y);
	switch (czas.dni&0x07){
	case 1:
	DispLcd("Pn");
	break;
	case 2:
	DispLcd("Wt");
	break;
	case 3:
	DispLcd("Sr");
	break;
	case 4:
	DispLcd("Cz");
	break;
	case 5:
	DispLcd("Pt");
	break;
	case 6:
	DispLcd("So");
	break;
	case 7:
	DispLcd("Nd");
	break;
	}
}
/*************************************************************
funkcja wywietlania dnia i nazwy miesiaca
/*************************************************************/
void DispMies(char x, char y){
	PosLcd(x,y);
	WriteRd(((czas.data&0x30)>>4)+0x30);//dziesiatki dni miesica
	WriteRd((czas.data&0x0f)+0x30);//jednostki dni miesica
	WriteRd(' ');
	switch ((((czas.mies&0x10)>>4)*10)+(czas.mies&0x0f)){//wyswietlanie nazwy miesica
	case 1:
	DispLcd("Sty");
	break;
	case 2:
	DispLcd("Lut");
	break;
	case 3:
	DispLcd("Mar");
	break;
	case 4:
	DispLcd("Kwi");
	break;
	case 5:
	DispLcd("Maj");
	break;
	case 6:
	DispLcd("Cze");
	break;
	case 7:
	DispLcd("Lip");
	break;
	case 8:
	DispLcd("Sie");
	break;
	case 9:
	DispLcd("Wrz");
	break;
	case 10:
	DispLcd("Paz");
	break;
	case 11:
	DispLcd("Lis");
	break;
	case 12:
	DispLcd("Gru");
	break;
	}
}
/*************************************************************
funkcja odczytania wszsytkich rejestrw czasu m41t00
/*************************************************************/
void ReadRTC(void){
	i2c_start();
	i2c_write(0xD0);	//adres slave R/W=0
	i2c_write(0);    	//adres pierwszego rejestru 
	i2c_start();		//powtrzony start
	i2c_write(0xD1);	//adres slave R/W=1
	czas.sek=i2c_read(0);//sekundy
	czas.min=i2c_read(0);//minuty
	czas.godz=i2c_read(0);//godziny
	czas.dni=i2c_read(0);//dni: Pn. Wt, Sr itp
	czas.data=i2c_read(0);//dni miesica 
	czas.mies=i2c_read(0);//miesiace
	czas.rok=i2c_read(1);//lata
	i2c_stop();
	
}

//*************************************************************
//funkcja zapisania rejestu control
//*************************************************************
void WriteControlRTC(unsigned char control){
	i2c_start();
	i2c_write(0xD0);	//adres slave R/W=0
	i2c_write(7);    	//adres rejestru config
	i2c_write(control);	//sekundy
	i2c_stop();
}
/*************************************************************
funkcja zapisania rejestrw czasu m41t00
/*************************************************************/
void WriteCzasRTC(void){
	i2c_start();
	i2c_write(0xD0);	//adres slave R/W=0
	i2c_write(0);    	//adres pierwszego rejestru 
	i2c_write(czas.sek);	//sekundy
	i2c_write(czas.min);	//minuty
	i2c_write(czas.godz);	//godziny
	i2c_stop();
}
/*************************************************************
funkcja zapisania rejestrw daty m41t00
/*************************************************************/
void WriteDataRTC(void){
	i2c_start();
	i2c_write(0xD0);	//adres slave R/W=0
	i2c_write(3);    	//adres rejestru dni
	i2c_write(czas.dni);
	i2c_write(czas.data);
	i2c_write(czas.mies);
	i2c_write(czas.rok);
	i2c_stop();
}	
/*************************************************************
funkcja ustawiania czasu 
/*************************************************************/
void SetCzasRTC(void){
unsigned char kl, tem;
	ClrLcd();
	ReadRTC();		//odczytanie RTC
	czas.sek=0x80;	//zatrzymanie zegara 
	PosLcd(1,1);
	DispLcd("godziny SW1 akc.");//wyswietlanie "pomocy"
	PosLcd(8,2);
	DispLcd("+SW2 -SW3");
	PosLcd(3,2);
	WriteRd(':');
	WriteRd('-');WriteRd('-'); //w pozycji minut 2 kreski
	tem=(((czas.godz&0x30)>>4)*10)+(czas.godz&0x0f);// liczba godzin binarnie
	while(1){
	DispDec(tem,1,2);
	while((PORTA&0x0f)==0x0f);	//klawisz zosta naciniety
	delay_ms(30);
	kl=(PORTA&0x0f);
	if(kl==SW_SW2)
	{++tem;
	 if(tem==24)
	 tem=0;
	}
	if(kl==SW_SW3)
	{--tem;
	 if(tem==0xff)
	 tem=23;
	}
	if(kl==SW_SW1)
	break;
	delay_ms(250);
	}
	delay_ms(300);
	czas.godz=((tem/10)<<4)|(tem%10);
    PosLcd(1,1);
    DispLcd("minuty  SW1 akc.");
	PosLcd(8,2);
	DispLcd("+SW2 -SW3");
	PosLcd(6,2);
	tem=(((czas.min&0x70)>>4)*10)+(czas.min&0x0f);// liczba minut binarnie
	while(1){
	DispDec(tem,4,2);
	while((PORTA&0x0f)==0x0f);	//klawisz zosta naciniety
	delay_ms(30);
	kl=(PORTA&0x0f);
	if(kl==SW_SW2)
	{++tem;
	 if(tem==60)
	 tem=0;
	}
	if(kl==SW_SW3)
	{--tem;
	 if(tem==0xff)
	 tem=59;
	}
	if(kl==SW_SW1)
	break;
	delay_ms(150);
	}
	czas.min=((tem/10)<<4)|(tem%10);
	WriteCzasRTC();
	ClrLcd();
	PosLcd(13,1);
	DispLcd("SW0");
	PosLcd(11,2);
	DispLcd("start");
	czas.zmsek=1;
	DispTime(1,2);
	while(1){
	kl=klaw();
	if(kl==SW_SW0)
	break;
	}
	czas.sek=0;//uruchomienie zegara zegar 
	WriteCzasRTC();
	ClrLcd();
	
}
/*************************************************************
funkcja ustawiania daty - bez korekcji zakresu dla miesicy
/*************************************************************/
void SetDataRTC(void){
unsigned char kl,tem;
	ReadRTC();
	ClrLcd();
	PosLcd(1,1);
	DispLcd("dzien tygodnia ");//ustawanie dnia tygodnia
	PosLcd(4,2);
	DispLcd("zmSW2 accSW1   ");
	tem=czas.dni&7;
	while(1){
	DispDay(1,2);	//wyswietlanie dnia tygodnia
	kl=klaw();
	if(kl==SW_SW2)
	{++tem;
	 if(tem==8)
	 tem=1;
	czas.dni=tem;
	}
	if(kl==SW_SW0)
	break;
	}
	ClrLcd();
	PosLcd(1,1);
	DispLcd("dzien miesiaca ");//ustawianie dnia miesica
	PosLcd(8,2);
	DispLcd("+SW2 -SW3");
	tem=(((czas.data&0x70)>>4)*10)+(czas.data&0x0f);//dzie miesica  binarnie
	while(1){
	DispDec(tem,2,2);
	while((PORTA&0x0f)==0x0f);	//klawisz zosta naciniety
	delay_ms(30);
	kl=(PORTA&0x0f);
	if(kl==SW_SW2)
	{++tem;
	 if(tem==32)
	 tem=1;
	}
	if(kl==SW_SW3)
	{--tem;
	 if(tem==0)
	 tem=31;
	}
	if(kl==SW_SW0)
	break;
	delay_ms(150);
	}
	czas.data=((tem/10)<<4)|(tem%10);
	ClrLcd();
	PosLcd(1,1);
	DispLcd("miesiac ");//ustawianie dnia miesica
	PosLcd(8,2);
	DispLcd("+SW2 -SW3");
	tem=(((czas.mies&0x70)>>4)*10)+(czas.mies&0x0f);//dzie miesica  binarnie
	while(1){
	DispMies(1,2);
	while((PORTA&0x0f)==0x0f);	//klawisz zosta naciniety
	delay_ms(30);
	kl=(PORTA&0x0f);
	if(kl==SW_SW2)
	{++tem;
	 if(tem==32)
	 tem=1;
	}
	if(kl==SW_SW3)
	{--tem;
	 if(tem==0)
	 tem=31;
	}
	if(kl==SW_SW0)
	break;
	delay_ms(150);
	czas.mies=((tem/10)<<4)|(tem%10);
	}
	WriteDataRTC();
	ClrLcd();

}
//wyswietlenie wartoci data w postaci 2 cyfr dziesietnie 00hex....99hex 
void DispDec(unsigned char data, char x, char y){
	PosLcd(x,y);
	WriteRd((data/10)+0x30);
    WriteRd((data%10)+0x30);
	 	
}
//obsuga klawiatury
unsigned char klaw(void){
unsigned char kl;

	while((PORTA&0x0f)==0x0f)//czekaj na przycinicie klawisza
    kl=PORTA&0x0f;
    delay_ms(30);
    kl=PORTA&0x0f;
    while((PORTA&0x0f)!=0x0f);//czekaj na zwolnienie klawisza
    return(kl);
}
void delay_ms(unsigned int msek){
	mSec=msek;
	TMR0|=131;
	tms=1;
	while(tms);
}



