#include <pic.h>
#include "i2c.h"

struct {
	unsigned char  sek;
	unsigned char  min;
	unsigned char  godz;
	unsigned char  dni;
	unsigned char  data;
	unsigned char  mies;
	unsigned char  rok;
	unsigned char  zmsek;
}czas;
void ReadRTC(void);

unsigned char  const led_konw[10]={0x40,0x79,0x24,0x30,0x19,0x12,0x02,0x78,0x00,0x10};
unsigned char  const an_konw[4]={0x07,0x0b,0x0d,0x0e};
unsigned char  led_buf[4]={1,9,6,2};
unsigned char  led_l,led_c,led_kr;
unsigned char port_isr;



static void interrupt
isr(void){         // przerwanie od Timer0
	++led_l;
	led_l=(led_l&3);
	led_c=led_buf[led_l];
	PORTA=an_konw[led_l];
	if(led_l==led_kr)
	PORTD=led_konw[led_c];
	else
	PORTD=led_konw[led_c]|0x80;
	T0IF = 0;         // clear the interrupt flag
}
 
void main(void){
	TRISA=0;
	TRISD=0;
	ANSEL=0; //wyaczenie ADC
	ANSELH=0;
	OPTION=0b00000100;//ustawienie TMR0
	TMR0=0;
	T0IE = 1;		// odblokowanie przerwania od przepelnienia TMR0
	GIE = 1;		// Global interrupt enable
	led_kr=1;
	OpenI2C();
	while(1){
	ReadRTC();
	led_buf[0]=(czas.godz>>4)&3;
	led_buf[1]=czas.godz&0x0f;
	led_buf[2]=(czas.sek>>4)&7;
	led_buf[3]=czas.sek&0x0f;
	}
}
/*************************************************************
funkcja odczytania  rejestrw czasu m41t00
/*************************************************************/
void ReadRTC(void){
	i2c_start();
	i2c_write(0xD0);	//adres slave R/W=0
	i2c_write(0);    	//adres pierwszego rejestru 
	i2c_start();		//powtrzony start
	i2c_write(0xD1);	//adres slave R/W=1
	czas.sek=i2c_read(0);//sekundy
	czas.min=i2c_read(0);//minuty
	czas.godz=i2c_read(1);//godziny
	i2c_stop();
	
	
}
